package security.xtext.bmpn.simple.ui.editor;

import java.util.Collections;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.presentation.EcoreEditor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.xtext.ui.editor.LanguageSpecificURIEditorOpener;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;

/**
 * This class is an editor opener that opens the EMF reflective tree editor when the user
 * follows a reference to an XMI-defined BPMN element in the bpucon Xtext editor.
 */
@SuppressWarnings("all")
public class ReflectiveTreeEditorOpener extends LanguageSpecificURIEditorOpener {
  @Override
  protected void selectAndReveal(final IEditorPart openEditor, final URI uri, final EReference crossReference, final int indexInList, final boolean select) {
    String _fragment = uri.fragment();
    boolean _tripleNotEquals = (_fragment != null);
    if (_tripleNotEquals) {
      if ((openEditor instanceof EcoreEditor)) {
        final EObject eObject = ((EcoreEditor)openEditor).getEditingDomain().getResourceSet().getEObject(uri, true);
        ((EcoreEditor)openEditor).setSelectionToViewer(Collections.<Object>unmodifiableList(CollectionLiterals.<Object>newArrayList(eObject)));
      }
    }
  }

  @Override
  protected String getEditorId() {
    return "org.eclipse.emf.ecore.presentation.ReflectiveEditorID";
  }
}
