package security.xtext.bmpn.simple;

import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import java.util.function.Consumer;
import org.eclipse.xtext.ISetup;
import org.eclipse.xtext.resource.FileExtensionProvider;
import org.eclipse.xtext.resource.IResourceServiceProvider;
import org.eclipse.xtext.xbase.lib.Extension;

/**
 * This class is needed for standalone runtime tests.
 */
@SuppressWarnings("all")
public class BPMN2StandaloneSetup implements ISetup {
  @Inject
  @Extension
  private FileExtensionProvider _fileExtensionProvider;

  @Inject
  @Extension
  private IResourceServiceProvider.Registry _registry;

  @Inject
  private IResourceServiceProvider resourceServiceProvider;

  @Override
  public Injector createInjectorAndDoEMFRegistration() {
    Injector _xblockexpression = null;
    {
      BPMN2RuntimeModule _bPMN2RuntimeModule = new BPMN2RuntimeModule();
      final Injector injector = Guice.createInjector(_bPMN2RuntimeModule);
      injector.injectMembers(this);
      final Consumer<String> _function = (String it) -> {
        this._registry.getExtensionToFactoryMap().put(it, this.resourceServiceProvider);
      };
      this._fileExtensionProvider.getFileExtensions().forEach(_function);
      _xblockexpression = injector;
    }
    return _xblockexpression;
  }
}
